<?php
declare(strict_types = 1);
namespace app\common\controller;

use support\View;
use Webman\Event\Event;

abstract class Base
{
    //  定义公用参数
    protected $request;
    //  定义网站配置参数
    protected $webdb;
    protected $WebPublic;
    //  定义用户数据
    protected $ImUser;
    public function __construct()
    {
        $this->request = request();
        $this->initialize();
    }
    //  定义是否获取数据
    protected $ModelGetList = false;
    //  定义页面基础数据
    protected $list_base;
    //  定义Get请求
    protected $getdata;
    protected $space_name = 'home';
    protected function initialize(){
        $this->webdb = GetWebDb();
        $this->WebPublic = GetServer($this->webdb['public'],false);
        $this->webdb = GetServer($this->webdb);

        $this->list_base = [
            'base_part' => '',
            'template' => '',
            'page' => true,
        ];
        $this->ImUser = $this->request->ImUser;
        $this->getdata = DataTrim($this->request->all());
        $this->getdata = DelNull($this->getdata);
        View::assign(['webdb' => $this->webdb,'imuser' => $this->ImUser]);
    }
    //  设置模板信息
    protected function SetView($data = []){
        $viewconf = config('view.options');
        $viewconf = array_merge($viewconf,$data);

        $viewconf['tpl_replace_string']['__MOD__'] = "/{$viewconf['app']}/{$viewconf['default_dir']}/images";
        $viewconf['view_path'] = is_dir("public/{$viewconf['app']}/{$viewconf['default_dir']}/template") ? "public/{$viewconf['app']}/{$viewconf['default_dir']}/template/" : "public/{$viewconf['app']}/default/template/";

        return $viewconf;
    }
    protected $model;
    /**
     * 定义模型
     * @param $modelName 模型名称
     * @param $name 指定变量名称
     * @param $model 所属模块
     * @return void
     */
    protected function BaseModel($modelName = '',$name = '',$model = ''){
        $_model = empty($model) ? "app\\common\\model" : 'app\\' . $model ."\\model";
        if(empty($modelName)){
            $modelName = explode("\\",request()->controller);
            $modelName = end($modelName);
        }
        $m = $_model .'\\'. $modelName;
        $name = $name ?: 'model';
        $this->$name = new $m;
    }
    /**
     * 定义验证规则
     * @param string $validateName 验证器名称
     * @param string $validir   验证器路径
     */
    protected $validate;
    protected function BaseValidate($validateName = '',$validir = ''){
        $validir = empty($validir) ? 'app\common\validate' : 'app\\' . $validir .'\validate';
        if(empty($validateName)){
            $validateName = explode("\\",request()->controller);
            $validateName = end($validateName);
        }
        $validateName = $validir . '\\' . $validateName;
        $this->validate = new $validateName;
    }
    //  获取模板信息
    protected function GetViewFile($template = ''){
        $_request = request();
        $options = config('view.options');
        $template = implode('/',explode(':', $template));
        //  获取路径
        $path = public_path("/{$_request->viewconf['app']}/{$_request->viewconf['default_dir']}/template/");
        //  拼接模板地址
        $res = "{$path}{$template}.{$options['view_suffix']}";
        if(!is_file($res)){
            $path = public_path("/{$_request->viewconf['app']}/{$options['default_dir']}/template/");
            $res = "{$path}{$template}.{$options['view_suffix']}";
        }
        return ['code' => !is_file($res) ? '0' : '1','template' => $res];
    }
    // 检测权限
    protected $user_auth = [
        'index' => false,
        'read' => false,
        'create' => false,
        'edit' => false,
        'del' => false,
    ];
    protected function CheckAuth($data,$model = '',$cname = ''){
        if(empty($cname)){
            $cname = explode('\\',$this->request->controller);
            $cname = end($cname);
        }
        if(empty($this->ImUser)){
            return [];
        }
        $res = Event::emit('auth.CheckAuth',['fid' => $this->ImUser['u_groupid'],'model' => $model ?: $this->space_name,'check' => $data,'cname' => $cname ?: $this->request->controller]);
        $this->user_auth = $res['0'];
        return $res['0'];
    }
    //  分配TDK
    protected function EditTdk($data = []){
        $this->WebPublic['web_title'] = empty($data['title']) ? $this->WebPublic['web_title'] : "{$data['title']}_{$this->WebPublic['web_title']}";
        $this->WebPublic['web_keywords'] = $data['keywords'] ?? $this->WebPublic['web_keywords'];
        $this->WebPublic['web_description'] = $data['description'] ?? $this->WebPublic['web_description'];
        View::assign(['webdb' => $this->WebPublic]);
    }
    //  检测是否登录
    protected function IsLogin(){
        return !empty($this->ImUser);
    }
}